//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma link "Disptch"
#pragma link "Grids"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//--------------------------------------------------------------------------- 
void __fastcall TForm1::FormShow(TObject *Sender)
{
int i,k;
struct ffblk ffblk;
char buf[80];

Dsp->Queue->OnChange = QueueChange;

k=findfirst("PICTURES\\*.bmp",&ffblk,0);
while (!k) {
  for (i=0; i<=strlen(ffblk.ff_name); i++) 
       buf[i]=tolower(ffblk.ff_name[i]);
  ListBoxS1->Items->Add(buf); 
  k=findnext(&ffblk); }
ListBoxS1->ItemIndex = 0;
ImageS1->Picture->LoadFromFile(
    "Pictures\\" + ListBoxS1->Items->Strings[ListBoxS1->ItemIndex]); 
PictureHeight=24;

ListBoxS2->ItemIndex = 0;
ListBoxS3->ItemIndex = 0;

EditQ1->Text = IntToStr(Dsp->Count);   
DrawGridQ1->DefaultRowHeight=PictureHeight+10;
DisplayEnabled();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::QueueChange(TObject *Sender)
{
EditQ1->Text = IntToStr(Dsp->Count);   
DrawGridQ1->Refresh();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonStartClick(TObject *Sender)
{
Dsp->Enabled=True;
DisplayEnabled();	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ButtonStopClick(TObject *Sender)
{
Dsp->Enabled=False;
DisplayEnabled();		
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DisplayEnabled()
{
if (Dsp->Enabled) {
  EditQ2->Text=" True";
  ButtonStart->Enabled=False;
  ButtonStop->Enabled=True; }
else {
  EditQ2->Text=" False";
  ButtonStart->Enabled=True;
  ButtonStop->Enabled=False; }  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DrawGridQ1DrawCell(TObject *Sender, long Col, long Row,
	TRect &Rect, TGridDrawState State)
{
if (Row==0) {
  if (Col==0) DrawGridQ1->Canvas->TextOut(Rect.Left+5,Rect.Top+5,"Ident");	
  if (Col==1) DrawGridQ1->Canvas->TextOut(Rect.Left+5,Rect.Top+5,"Object");	
  }
else if (Row <= Dsp->Count) {
  if (Col==0) 
  DrawGridQ1->Canvas->TextOut(Rect.Left+5,Rect.Top+5,Dsp->Queue->Strings[Row-1]);	
  if ((Col==1) && Dsp->Queue->Objects[Row-1]) 
  DrawGridQ1->Canvas->Draw(Rect.Left+5,Rect.Top+5,
        ((TPicture *)Dsp->Queue->Objects[Row-1])->Graphic);	
  }  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtnAddClick(TObject *Sender)
{
TPicture *Obj;
Obj = new TPicture;
Obj->Assign(ImageS1->Picture);
Dsp->Queue->AddObject(ListBoxS2->Items->Strings[ListBoxS2->ItemIndex],Obj);	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtnDelClick(TObject *Sender)
{
if ((DrawGridQ1->Row > 0) && (DrawGridQ1->Row <= Dsp->Count))
  Dsp->Queue->Delete(DrawGridQ1->Row - 1);
else MessageBox(0,"No Queue element selected","Delete error",MB_OK);  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ListBoxS1Click(TObject *Sender)
{
ImageS1->Picture->LoadFromFile(
    "Pictures\\" + ListBoxS1->Items->Strings[ListBoxS1->ItemIndex]);  
//MessageBox(0,ListBoxS1->Items->Strings[ListBoxS1->ItemIndex].c_str(),"LL",MB_OK);  
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DspDispatch(TObject *Sender, AnsiString Ident,
	TObject *Environ)
{
int ret;
// for Form2:
PictureObject = (TPicture *)Environ;
strcpy(ExecName,Ident.c_str());
strcpy(Action,ListBoxS3->Items->Strings[ListBoxS3->ItemIndex].c_str()); 	
ret = Form2->ShowModal();
if (ret==mrYes) Dsp->Enabled=False;
DisplayEnabled();	
}
//---------------------------------------------------------------------------